/*
 * Copyright (C) 1997 Wolfgang Moser
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "pavlnode.h"

void PathAVLnode::rotate(const nodeside Side,PathAVLnode *&Father){
      // wenn links  rotieren, dann rechter Sohn
   PathAVLnode *Ptmp=Father->Node[!Side];
      // wenn links  rotieren, dann linker  Sohn
   Father->Node[!Side]=Ptmp->Node[Side];
   Ptmp->Node[Side]=Father;
   Father=Ptmp;
   }

void PathAVLnode::rebalanceAdded(const nodeside Side,
                                 PathAVLnode *&Father){
   int SBal=Side?-1:+1;    // Side==LEFT  ==> SBal=+1
                           // Side==RIGHT ==> SBal=-1

   PathAVLnode *&son=Father->Node[Side];

   // Wenn Side==LEFT, dann Rotationen nach rechts

   if(son->Balance==-SBal) Father->Balance=0;
   else{
      Father->Balance=
         (son->Node[!Side]->Balance== -SBal) ?  SBal :  0;
      son->Balance=
         (son->Node[!Side]->Balance==  SBal) ? -SBal :  0;
      rotate(Side,son);
         // erste und zweite Stufe zur Doppelrotation
      }
   rotate((!Side)?RIGHT:LEFT,Father);

      // Nach der Rotation den Vater immer auf 0 setzen
   Father->Balance=0;
   }

int PathAVLnode::rebalanceRemoved(const nodeside Side,
                                  PathAVLnode *&Father){
   int SBal, Ready;

   Ready=0;
   SBal=Side?-1:+1;  // Side==LEFT  ==> SBal=+1
                     // Side==RIGHT ==> SBal=-1

   // Wenn Side==LEFT, also 0, dann alles normal (mit 1 malnehmen),
   // andernfalls die Flle -1 und 1 genau vertauschen (mit -1 malnehmen)

   switch((Father->Balance) * SBal){
      case  0:
         Ready++;
      case -1:
         Father->Balance+=SBal;  // ++ fr LEFT, -- fr RIGHT
         break;
      case  1:
                        // Darf KEINE Refernz sein
         PathAVLnode *son=Father->Node[!Side];

         if(son->Balance * SBal ==-1)
            rotate((!Side)?RIGHT:LEFT,Father->Node[!Side]);
         rotate(Side,Father);
         switch(son->Balance * SBal){
            case  0:
               Father->Balance=-SBal;
               Ready++;
               break;
            case  1:
               Father->Balance=Father->Node[Side]->Balance=0;
               break;
            case -1:
               //Father->Node[!Side]
               son->Balance               =(Father->Balance==-SBal)? SBal:0;
               Father->Node[Side]->Balance=(Father->Balance== SBal)?-SBal:0;
               Father->Balance=0;
            }
      }
   return Ready;
   }
