/*
 * Copyright (C) 1997 Wolfgang Moser
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __menues_h_deklaration
#define __menues_h_deklaration

#include "central.h"
#include <iostream.h>

class menues{
   public:
      void             clrscr    (void)const;
      void             gotozs    (const unsigned int =1,
                                  const unsigned int =1)const;
      void             errormsg  (void)const;
      int              readchoice(signed char &, const char *const)const;
   private :
      const int        included  (const char, const char *)const;
      void             clrlns    (const unsigned int, unsigned int=1)const;
   };

inline void menues::clrscr(void)const {
   cout << "\x1b[2J\x1b[1;1H" << flush;
   }

inline void menues::gotozs(const unsigned int y,
                           const unsigned int x)const{
   cout << "\x1b[" << y << ';' << x << 'H' << flush;
   }

#endif
/***************************************************************************\

Eine einfache Menstruktur wre zum Beispiel folgendermaen denkbar:


int    ret;
char   e;
menues Menu;

   do{
      Menu.gotozs(1,1);
      cout << " Menauswahl: A,B,C,D,Q " << flush;

      ret=Menu.readchoice(e,"AaBbCcDdQq");
      Menu.clrscr();
      if(!ret) continue;

      switch (e){
         case 'A': case 'a': ret=myfunction1(); break;
         case 'B': case 'b': ret=myfunction2(); break;
         case 'C': case 'c': ret=myfunction3(); break;
         case 'D': case 'd': ret=myfunction4(); break;
         default :           ret=1;e=0; // Kann ja nur noch 'Q' oder 'q' sein
         }
      Menu.clrscr();
      if(!ret) Menu.errormsg();
      }while (e);

\***************************************************************************/

