/*
 * Copyright (C) 1997 Wolfgang Moser
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Wolfgang Moser
 *
 * PathAVLTree, an iterative implemented AVL-Tree, Version 199705312200
 *
 * 1997, May 31, 22:00
 *
 */

/*
 * A very simple node. I need it for some sample applications
 */

#ifndef _SimpleNode_Long_
#define _SimpleNode_Long_

#include "pavlnode.h"

class simpleNodeLong:public PathAVLnode{
   public:
      simpleNodeLong(long);

      int         GT    (simpleNodeLong *&);
      int         NE    (simpleNodeLong *&);

      long&       Ref  (void);
      const long  get   (void)const;

   private:
      long        Element;
   };

inline simpleNodeLong::simpleNodeLong(long kEl)
   : Element(kEl){
   }

inline int simpleNodeLong::GT(simpleNodeLong *&arg){
   return Element>(arg->Element);
   }

inline int simpleNodeLong::NE(simpleNodeLong *&arg){
   return Element!=(arg->Element);
   }

inline long& simpleNodeLong::Ref(void){
   return Element;
   }

inline const long simpleNodeLong::get(void)const{
   return Element;
   }

#endif

