#include <stdlib.h>
#ifndef __GNUG__
#  if defined __BORLANDC__
#     include <alloc.h>
#  elif defined __WATCOMC__
         // WatCOM hat keine coreleft-Funktion, sondern nur _memavl
#     include <malloc.h>
#  endif
#endif
#include <iostream.h>
#include <iomanip.h>

#include "nodelong.h"
#include "treelong.h"
#include "menues.h"

int main(void){
   int         ret;
   signed char e;
   menues      Menu;

   simpleNodeLong       *nNode;
   simpleNodeLong       *rNode;
   const simpleNodeLong *cNode;
   EnhTreeLong           Tree;
   long                  Value;

   Menu.clrscr();
   do{
      Menu.gotozs(1,1);
      cout << " Menuchoices: (A)dd, (R)emove, (S)earch, (D)elete, (P)rint, (T)raverse, (Q)uit " << flush;

      ret=Menu.readchoice(e,"AaRrSsDdPpTtQq");
      Menu.clrscr();
      if(!ret) continue;

      Menu.gotozs(2,1);
      switch (e){
         case 'A': case 'a':
            cout << "Value to insert: " << flush;
            cin >> Value;
            nNode=new simpleNodeLong (Value);
            ret=Tree.add(nNode);
            if(!ret){
               cout << "Node already exists in Tree!" << endl;
               delete nNode;
               }
            break;
         case 'R': case 'r':
            cout << "Value to remove: " << flush;
            cin >> Value;
            nNode=new simpleNodeLong (Value);
            rNode=Tree.remove(nNode);
            if(rNode==NULL){
               cout << "Node not found!" << endl;
               ret=0;
               }
            else{
               cout << "Removed Node: " << rNode->get() << endl;
               ret=1;
               }
            delete nNode;
            delete rNode;
            break;
         case 'S': case 's':
            cout << "Value to search: " << flush;
            cin >> Value;
            nNode=new simpleNodeLong (Value);
            cNode=Tree.search(nNode);
            if(cNode==NULL){
               cout << "Node not found!" << endl;
               ret=0;
               }
            else{
               cout << "Encountered Node: " << cNode->get() << endl;
               ret=1;
               }
            delete nNode;
            break;
         case 'D': case 'd':
            Tree.empty();
            break;
         case 'P': case 'p':
//            Tree.print();
            ret=1;
            break;
         case 'T': case 't':
            cout << "Traversing over all nodes (inorder):" << endl;
            cNode=NULL;
            while((cNode=Tree.nextIter(cNode))!=NULL)
               cout << "aktueller Knoten: " << cNode->get() << endl;
            ret=1;
            break;
         default :           ret=1;e=0; // Kann ja nur noch 'Q' oder 'q' sein
         }
         Tree.print();
#ifndef __GNUG__
#ifdef __BORLANDC__
   cout << "coreleft= " <<  coreleft() << " bytes." << endl;
#elif __WATCOMC__
   cout << "coreleft= " <<  _memavl() << " bytes." << endl;
#endif
#endif
//    Menu.clrscr();
      if(!ret) Menu.errormsg();
      }while (e);
   return 0;
   }
